import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { EquipmentGoods, EquipmentGoodsParam } from './model';

/**
 * 分页查询商品
 */
export async function pageEquipmentGoods(params: EquipmentGoodsParam) {
  const res = await request.get<ApiResult<PageResult<EquipmentGoods>>>(
    '/apps/equipment-goods/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品列表
 */
export async function listEquipmentGoods(params?: EquipmentGoodsParam) {
  const res = await request.get<ApiResult<EquipmentGoods[]>>(
    '/apps/equipment-goods',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品
 */
export async function addEquipmentGoods(data: EquipmentGoods) {
  const res = await request.post<ApiResult<unknown>>(
    '/apps/equipment-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品
 */
export async function updateEquipmentGoods(data: EquipmentGoods) {
  const res = await request.put<ApiResult<unknown>>(
    '/apps/equipment-goods',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品
 */
export async function removeEquipmentGoods(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/apps/equipment-goods/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品
 */
export async function removeBatchEquipmentGoods(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/apps/equipment-goods/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    '/apps/equipment-goods/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
